Attribute VB_Name = "mainmod"
Option Explicit

Public Const ProgramName As String = "Zega Alpha"
Public Const ProgramVersion As String = "3.2.1"
Public Const ProgramBuildDate As String = "Dec 27, 2012"

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
    
Public GameDirectory As String
Public Region As Integer
Public cartRam(8192) As Byte 'Cart RAM.  (8K)
Public cartRom(49152) As Byte 'ROM Pages, 0,1,2 (SaveRAM)
Public frame_two_rom As Long 'Does frame 2 use ROM or SRAM.
Public glMemAddrDiv256(65535) As Long 'Lookup table for speed division.
Public GameGear As Boolean 'checks to see if it's a game gear game or not
Public Mul4000() As Long 'Lookup table for * &H4000&
Public number_of_pages As Long 'How many pages exist in a ROM.
Public pages() As Byte 'Holds ROM file data.
Public ROM_Name As String 'holds the rom's name in ram
Public ShiftRight(600, 1 To 10) As Long 'Lookup table for speed ShiftRight.
Public ShiftLeft(600, 1 To 10)  As Long 'Lookup table for speed ShiftLeft.
Public SRAM(16384) As Byte 'Cartridge Ram Page 1 (Save RAM).
Public MemoryEditorOpen As Boolean 'checks if the memory editor is open

Public Const Page1 As Long = &H4000& 'Value For Page 1, (Memory Mapping).
Public Const Page2 As Long = &H8000& 'Value For Page 2, (Memory Mapping).

Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (dest As Any, src As Any, ByVal cb As Long)
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal _
    lpFileName As String, ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, lpSecurityAttributes As Any, _
    ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As _
    Long
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, _
    ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, _
    ByVal dwMoveMethod As Long) As Long
Private Declare Function SetEndOfFile Lib "kernel32" (ByVal hFile As Long) As _
    Long
Private Const FILE_BEGIN = 0
Private Const OPEN_EXISTING = 3
Private Const INVALID_HANDLE_VALUE = -1
Private Const GENERIC_WRITE = &H40000000


Const CCHDEVICENAME = 32
Const CCHFORMNAME = 32

Private Type DEVMODE
    dmDeviceName As String * CCHDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCHFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
End Type

Private Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (lpInitData As DEVMODE, ByVal dwFlags As Long) As Long
Private Declare Function EnumDisplaySettings Lib "user32" Alias "EnumDisplaySettingsA" (lpszDeviceName As Any, ByVal iModeNum As Long, lpDevMode As Any) As Boolean
Private Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long

Const DM_BITSPERPEL = &H40000
Const DM_PELSWIDTH = &H80000
Const DM_PELSHEIGHT = &H100000
Const DM_DISPLAYFLAGS = &H200000
Const DM_DISPLAYFREQUENCY = &H400000
Const BITSPIXEL = 12
Const CDS_UPDATEREGISTRY = &H1
Const CDS_TEST = &H2
Const CDS_FULLSCREEN = &H4
Const CDS_GLOBAL = &H8
Const CDS_SET_PRIMARY = &H10
Const CDS_RESET = &H40000000
Const CDS_SETRECT = &H20000000
Const CDS_NORESET = &H10000000
Const DISP_CHANGE_SUCCESSFUL = 0
Const DISP_CHANGE_RESTART = 1
Const DISP_CHANGE_FAILED = -1
Const DISP_CHANGE_BADMODE = -2
Const DISP_CHANGE_NOTUPDATED = -3
Const DISP_CHANGE_BADFLAGS = -4
Const DISP_CHANGE_BADPARAM = -5
Const EWX_LOGOFF = 0
Const EWX_SHUTDOWN = 1
Const EWX_REBOOT = 2
Const EWX_FORCE = 4

Dim d() As DEVMODE, lNumModes As Long

' Extend or trim a file to a given length.
' If the file is extended, the added bytes are undefined

Public Sub SetFileSize(ByVal filename As String, ByVal newSize As Long)
    Dim fileHandle As Long
    
    ' open the file, get the handle
    fileHandle = CreateFile(filename, GENERIC_WRITE, 0&, ByVal 0&, _
        OPEN_EXISTING, 0&, 0&)
    
    ' raise error if not found
    If fileHandle = INVALID_HANDLE_VALUE Then
        err.Raise 53     ' This is "file not found"
    End If
    
    ' move the file pointer to new position, raise error if fails
    If SetFilePointer(fileHandle, newSize, 0&, FILE_BEGIN) = -1 Then
        CloseHandle fileHandle
        err.Raise 5     ' this is "illegal function call"
    End If
    
    ' attempt to set the end of file, raise error
    If SetEndOfFile(fileHandle) = 0 Then
        CloseHandle fileHandle
        err.Raise 5     ' this is "illegal function call"
    End If
    
    ' close the file and exit
    CloseHandle fileHandle
End Sub
Public Function fixvalue(a As String) As String 'fixes the addy so it's 2 characters
  If Len(a$) = 1 Then fixvalue = "0" & a$: Exit Function
  fixvalue = a$
End Function
Public Function fixaddress(a As String) As String 'fixes the addy so it's 4 characters
  If Len(a$) = 1 Then fixaddress = "000" & a$: Exit Function
  If Len(a$) = 2 Then fixaddress = "00" & a$: Exit Function
  If Len(a$) = 3 Then fixaddress = "0" & a$: Exit Function
  fixaddress = a$
End Function
Public Sub compatibiltyhacks(hash As String)

  'Call InputBox("", "", hash$)
  'NEED NINJA GAIDEN, DOWNLOAD ROM
  
  VDP_SpiderHack = False
  VDP_3DDisable = False

  Select Case hash$
    Case "28C72640": VDP_SpiderHack = True 'last action hero, same company
    Case "45C6BED3": pages(&H1FA13) = &H0&: pages(&H1FA13 + 1) = &H0&: pages(&H1FA13 + 2) = &H0& 'alex kidd (kr) bios
    Case "BC48365D", "C3EED5C9": VDP_SpiderHack = True 'spiderman sinister six sms and gg
    Case "DF400BEE": pages(&H1C12F) = &H0&: pages(&H1C12F + 1) = &H0&: pages(&H1C12F + 2) = &H0& 'hang on/safari hunt bios
    Case "6A2AA22B": pages(&H17EDE) = &H0&: pages(&H17EDE + 1) = &H0&: pages(&H17EDE + 2) = &H0& 'alex kidd in miracle world bios
    Case "5A9E9435": pages(&H26FA) = &H0&: pages(&H26FA + 1) = &H0&: pages(&H26FA + 2) = &H0&  'sonic euro bios
    Case "C2FF32": pages(&HFB5) = &HDD&: pages(&HFB5 + 1) = &H4E&: pages(&HFB5 + 2) = &HFF&  '20 em 1
    Case "8BD837E9": pages(&H45D) = &H0&: pages(&H45D + 1) = &H0& 'wanted
    Case "8E620D1B": pages(&H173) = &HC& 'sports pad soccer
    Case "ED26A448": pages(&H5A7) = &HAF&: pages(&H5A7 + 1) = &H0& 'american pro football
    Case "B343492D": pages(&H592) = &HAF&: pages(&H592 + 1) = &H0&  'walter payton
    Case "A5F1F4DE": pages(&H25B) = &H0&: pages(&H25B + 1) = &H0& 'wonder boy 3
    Case "2894DD55": pages(&H25B) = &H0&: pages(&H25B + 1) = &H0& 'monica em o res
    Case "34BF6FAD": VDP_3DDisable = True 'harrier 3d jap
    Case "ECF62447": VDP_3DDisable = True 'missile defense 3d bios
    Case "A4D75E8F": VDP_3DDisable = True 'blade eagle or something
    Case "69BE47B": VDP_3DDisable = True 'blade eagle beta
    Case "CDF39068": VDP_3DDisable = True 'maze hunter 3d
    Case "6C62CB4": VDP_3DDisable = True 'missile
    Case "2558AE10": VDP_3DDisable = True 'outrun 3d
    Case "6451E0C5": VDP_3DDisable = True 'poseidon
    Case "1DD501DA": VDP_3DDisable = True 'space harrier
    Case "4B0C95CB": VDP_3DDisable = True 'zaxxon beta
    Case "48B59D40": VDP_3DDisable = True 'zaxxon
  End Select

End Sub
Public Function fileexists(sFileName As String) As Boolean

  If sFileName$ = "" Then
    fileexists = False
    Exit Function
  End If

  If Len(Dir$(sFileName$)) Then
    fileexists = True
  Else
    fileexists = False
  End If

End Function
Public Sub FormSizeFrame(frm As Form, fram As Control)

  frm.Height = 0
  frm.Width = 0
  
  Do
    frm.Width = frm.Width + 1
  Loop Until frm.ScaleWidth = fram.Left + fram.Left + fram.Width
  Do
    frm.Height = frm.Height + 1
  Loop Until frm.ScaleHeight = fram.Top + fram.Top + fram.Height
  
End Sub


Public Function filenameextract(filea As String) As String

  Dim a As String, b As String

  a$ = filea$
  b$ = filea$

  Do
    a$ = Left(a$, Len(a$) - 1)
  Loop Until Right$(a$, 1) = "\"

  b$ = Mid$(b$, Len(a$) + 1)
  
  If LCase(Right(b$, 3)) = ".gg" Then
    a$ = Left$(b$, Len(b$) - 3)
  Else
    a$ = Left$(b$, Len(b$) - 4)
  End If

  filenameextract$ = a$

End Function
Public Function directoryextract(filea As String) As String

  Dim a As String, b As String

  a$ = filea$
  b$ = filea$

  Do
    a$ = Left(a$, Len(a$) - 1)
  Loop Until Right$(a$, 1) = "\"

  b$ = Left(b$, Len(a$))

  directoryextract$ = b$

End Function

Public Function directoryexists(strDir As String) As Boolean

  On Error Resume Next

  If Right$(strDir$, 1) <> "\" Then
    strDir$ = strDir$ & "\"
  End If

  If Dir$(strDir$ & "*.*", vbDirectory) = "" Then
    directoryexists = False
  Else
    directoryexists = True
  End If

End Function

Private Sub Main() 'Program Entry Point.

  Call Resolutions
  Call frmSMS.mnuResolution_Click(frmSMS.lstResolutions.ListCount - 1)
  
  Dim X As Long, Y As Long, z As Long, bytArray(192) As Byte, a

  For a = 1 To 9
    Call Load(frmSMS.mnuRecentGame(a))
    frmSMS.mnuRecentGame(a).Visible = False
  Next a
  
  frmSMS.Caption = ProgramName & " " & ProgramVersion
  
  Call timeBeginPeriod(1&) 'fixes timing?

  OriginalScreenWidth = Screen.Width / 15
  OriginalScreenHeight = Screen.Height / 15

  Call settingsload

  Call samplerate

  frmSMS.mnuLoadROM.Caption = "&Load game..." & vbTab & "F1"
  frmSMS.mnuReset.Caption = "&Reset game" & vbTab & "Shift+Bkspc"
  frmSMS.mnuPause.Caption = "&Pause game" & vbTab & "Pause"
  frmSMS.mnuFullScreenToggle.Caption = "&Toggle full screen" & vbTab & "Esc"
  frmSMS.mnuAdvanceFrame.Caption = "&Manual step" & vbTab & "F11"
  frmSMS.mnuStateSave.Caption = "&Save" & vbTab & "F5"
  frmSMS.mnuStateLoad.Caption = "&Load" & vbTab & "F6"
  frmSMS.mnuMovieRecord.Caption = "&Record" & vbTab & "F7"
  frmSMS.mnuMoviePlay.Caption = "&Play" & vbTab & "F8"
  frmSMS.mnuRewind2.Caption = "&Rewind" & vbTab & "Bkspc"
  frmSMS.mnuSaveScreenshot.Caption = "&Save screenshot" & vbTab & "F12"
  frmSMS.mnuLayerBG.Caption = "&Background" & vbTab & "F9"
  frmSMS.mnuLayerSprites.Caption = "&Sprites" & vbTab & "F10"
  frmSMS.mnuFastForward.Caption = "&No throttle" & vbTab & "Tab"

  Call vdp.loadpalette 'load palette
  
  If directoryexists(App.Path & "\folders") = False Then Call MkDir(App.Path & "\folders") 'make folders directory
  If directoryexists(App.Path & "\folders\save states") = False Then Call MkDir(App.Path & "\folders\save states") 'make states directory
  If directoryexists(App.Path & "\folders\movie states") = False Then Call MkDir(App.Path & "\folders\movie states") 'make movies directory
  If directoryexists(App.Path & "\folders\screenshots") = False Then Call MkDir(App.Path & "\folders\screenshots") 'make screenshots directory
  If directoryexists(App.Path & "\folders\bookmarks") = False Then Call MkDir(App.Path & "\folders\bookmarks") 'make bookmarks directory
  If directoryexists(App.Path & "\folders\temporary") = False Then Call MkDir(App.Path & "\folders\temporary") 'make temporary directory
  If directoryexists(App.Path & "\folders\pro action replay") = False Then Call MkDir(App.Path & "\folders\pro action replay") 'make par directory
  If directoryexists(App.Path & "\folders\rewinds") = False Then Call MkDir(App.Path & "\folders\rewinds") 'make rewinds directory

  Pad_GameGear = 0& 'gg controller default
  StateSlot = 0 'current save slot
  MovieSlot = 0 'current movie slot
  MoviePlaying = False 'no movie playing
  MovieRecording = False 'no movie recording
  VDP_DrawBackground = True 'draw bg layer
  VDP_DrawSprites = True 'draw sprites layer
  steppy = False 'for frame advancing
  frame_two_rom = True

  For X = 0& To 65535 'Calculate Div \ 256.
    glMemAddrDiv256(X) = (X \ 256&)
  Next X

  For X = 0& To 255& 'Calculate Flag Parity.
    Y = True
    For z = 0& To 7&
      If (X And (2& ^ z)) <> 0& Then Y = Not Y
    Next z
    Parity(X) = Y
  Next X

  For X = 1& To 600& 'Calculate Bit Shifts.
    z = 2
    For Y = 1& To 10&
      ShiftRight(X, Y) = (X \ z)
      ShiftLeft(X, Y) = (X * z)
      z = z * 2
    Next Y
  Next X
  
  ReDim Mul4000(64) 'Calculate Page Lookup. Upto 1MB.
  For X = 0 To 64
    Mul4000(X) = X * Page1
  Next X

  With myBMP.bmiHeader 'SMS Screen Setup.
    .biWidth = SMS_WIDTH
    .biHeight = -SMS_HEIGHT
    .biSize = 40
    .biBitCount = 32
    .biPlanes = 1
  End With

  Call windowscale(VDP_Zoom)

  Call frmSMS.Show

  If Command$ <> "" Then
    Call loadrom(Replace(Command$, Chr$(34), ""))
  End If

End Sub
Public Function RightSide(MyString As String) As String
  RightSide$ = Right(MyString$, Len(MyString$) - InStr(MyString$, "x"))
End Function

Public Function LeftSide(MyString As String) As String
  LeftSide$ = Left(MyString$, InStr(MyString$, "x") - 1)
End Function



Public Sub Resolutions()
    
  Dim l As Long, lMaxModes As Long, hdc As Long, lBits As Long, lWidth As Long, lHeight As Long, a
  
  lBits = GetDeviceCaps(hdc, BITSPIXEL)
  lWidth = Screen.Width \ Screen.TwipsPerPixelX
  lHeight = Screen.Height \ Screen.TwipsPerPixelY
  lMaxModes = 8
    
  ReDim d(0 To lMaxModes) As DEVMODE
    
  lNumModes = 0
  l = EnumDisplaySettings(ByVal 0, lNumModes, d(lNumModes))
        
  Do While l
    
    If frmSMS.lstResolutions.ListCount >= 1 Then
      For a = 0 To frmSMS.lstResolutions.ListCount
        If frmSMS.lstResolutions.List(a) = d(lNumModes).dmPelsWidth & "x" & d(lNumModes).dmPelsHeight Then GoTo 14
      Next a
    End If
    
    frmSMS.lstResolutions.AddItem d(lNumModes).dmPelsWidth & "x" & d(lNumModes).dmPelsHeight
14:
    If lBits = d(lNumModes).dmBitsPerPel And lWidth = d(lNumModes).dmPelsWidth And lHeight = d(lNumModes).dmPelsHeight Then
      frmSMS.lstResolutions.ListIndex = frmSMS.lstResolutions.NewIndex
    End If
    
    lNumModes = lNumModes + 1
    
    If lNumModes > lMaxModes Then
      lMaxModes = lMaxModes + 8
      ReDim Preserve d(0 To lMaxModes) As DEVMODE
    End If
    
    l = EnumDisplaySettings(ByVal 0, lNumModes, d(lNumModes))
    
  Loop
  
  lNumModes = lNumModes - 1
    
  For a = 0 To frmSMS.lstResolutions.ListCount - 1
    If a <> 0 Then Call Load(frmSMS.mnuResolution(a))
    frmSMS.mnuResolution(a).Caption = "&" & frmSMS.lstResolutions.List(a)
  Next a
  
End Sub

Public Sub WindowCenter(frm As Form)
  
  frm.Top = frmSMS.Top + frmSMS.Height / 2 - frm.Height / 2
  frm.Left = frmSMS.Left + frmSMS.Width / 2 - frm.Width / 2

End Sub

Public Sub windowscale(f)

  Dim a
41:
  a = f
  
  If f = 0 Then
    
    Do
      DoEvents
      a = a + 1
    Loop Until (a * 192) + 144 > (Screen.Height / 15) '144 is size of default win8 title bar
    a = a - 1
    
    GoTo 14
  
  Else
    
    If (a * 192) + 144 > (Screen.Height / 15) Then f = 0: GoTo 41
14:
    frmSMS.Height = 0
    frmSMS.Width = 0
    Do
      frmSMS.Width = frmSMS.Width + 1
    Loop Until frmSMS.ScaleWidth = 256 * a
    
    Do
      frmSMS.Height = frmSMS.Height + 1
    Loop Until frmSMS.ScaleHeight = 192 * a
  
  End If
  
  frmSMS.Image1.Left = 0
  frmSMS.Image1.Top = 0
  frmSMS.Image1.Width = frmSMS.picScreen.ScaleWidth
  frmSMS.Image1.Height = frmSMS.picScreen.ScaleHeight
  
  VDP_Zoom = a

End Sub

Public Sub loadrom(url As String) 'Read a cartridge into memory.

  Dim X As Long, Y As Long, z As Long, hash As String

  If fileexists(url$) = False Then Exit Sub 'checks if the file doesn't exist

  rewindnumber = 0
  
  If LCase$(Right$(url$, 3)) = "zip" Then 'checks if it's a zip file
    Dim oUnZip As CGUnzipFiles
    Set oUnZip = New CGUnzipFiles
    oUnZip.ZipFileName = url$ 'gets the filename
    oUnZip.ExtractDir = App.Path & "\folders\temporary\" 'sets the extraction directory
    Call oUnZip.unzip 'unzips it
    If fileexists(App.Path & "\folders\temporary\" & filenameextract(url$) & ".gg") = True Then url$ = App.Path & "\folders\temporary\" & filenameextract(url$) & ".gg" 'sets if it's gg
    If fileexists(App.Path & "\folders\temporary\" & filenameextract(url$) & ".sms") = True Then url$ = App.Path & "\folders\temporary\" & filenameextract(url$) & ".sms" 'sets if it's sms
    Set oUnZip = Nothing
  End If
  
  If fileexists(url) Then
    Open url For Binary As #1 'Read Cart into Memory.
    Y = LOF(1) 'Store File Length.
    z = Y Mod &H4000& 'check if it has a header (first 512 bytes, if so, skip)
    number_of_pages = (Y / &H4000&) 'Calculate Number of Pages.
    ReDim pages(Y) 'Redim Paging Array Accordingly.
    Get #1, z + 1, pages() 'Retrieve file data (header aware).
    Close #1
  Else
    Exit Sub
  End If
  
  frmSMS.Image1.Visible = False
  
  Call compatibiltyhacks(getcrc32(pages))

  'Default ROM Mapping.
  If (Y >= &HC000&) Then Y = &HC000&
  Call CopyMemory(cartRom(0), pages(0), Y)

  ROM_Name$ = filenameextract$(url$) 'stores rom name for use with save state filenames, etc.

  frmSMS.Caption = ProgramName & " " & ProgramVersion & " - " & ROM_Name$

  If LCase$(Right$(url$, 3)) = "sms" Then GameGear = False Else GameGear = True 'detects whether it's a SMS or GG game
  If PAROpen = True Then Call PARLoad 'checks if the par's open and clears/loads bookmarks
  If FullScreenOnROM Then Call frmSMS.mnuFullScreenToggle_Click 'checks whether to switch to full screen or not

  Pad_PaddlePosition(0) = 0&
  Pad_PaddlePosition(1) = 0&
  Call frmSMS.mnuReset_Click 'resets the SMS/GG
  Executing = True 'sets executing boolean operator
  Call z80.execute 'starts execution

End Sub
