Attribute VB_Name = "shared"
Option Explicit

Public cartRam(8192) As Byte 'Cart RAM.  (8K)
Public cartRom(49152) As Byte 'ROM Pages, 0,1,2 (SaveRAM)
Public frame_two_rom As Long 'Does frame 2 use ROM or SRAM.
Public FullScreenHeight As Integer 'full screen height
Public FullScreenOnROM As Boolean 'choose whether to change resolution on rom load or not
Public FullScreenWidth As Integer 'full screen width
Public glMemAddrDiv256(65535) As Long 'Lookup table for speed division.
Public IsFullScreen As Boolean 'checks to see if it's in full screen mode
Public IsGameGear As Boolean 'checks to see if it's a game gear game or not
Public Mul4000() As Long 'Lookup table for * &H4000&
Public number_of_pages As Long 'How many pages exist in a ROM.
Public OriginalScreenHeight As Integer 'original screen height
Public OriginalScreenWidth As Integer 'original screen width
Public pages() As Byte 'Holds ROM file data.
Public ROM_Name As String 'holds the rom's name in ram
Public ScreenResolutionChange As Boolean 'choose whether to change resolution on fullscreen toggling
Public ShiftRight(600, 1 To 10) As Long 'Lookup table for speed ShiftRight.
Public ShiftLeft(600, 1 To 10)  As Long 'Lookup table for speed ShiftLeft.
Public SRAM(16384) As Byte 'Cartridge Ram Page 1 (Save RAM).
Public DoPause As Boolean

Public Const CCDEVICENAME = 32
Public Const CCFORMNAME = 32
Public Const CDS_FULLSCREEN = &H4
Public Const DM_PELSHEIGHT = &H100000
Public Const DM_PELSWIDTH = &H80000
Public Const Page1 As Long = &H4000& 'Value For Page 1, (Memory Mapping).
Public Const Page2 As Long = &H8000& 'Value For Page 2, (Memory Mapping).
Public Const SMS_WIDTH As Long = 256& 'SMS Screen width
Public Const SMS_HEIGHT As Long = 192& 'SMS Screen height

Public Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (lpDevMode As Any, ByVal dwFlags As Long) As Long
Public Declare Function EnumDisplaySettings Lib "user32" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, lpDevMode As Any) As Boolean
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Public Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (dest As Any, src As Any, ByVal cb As Long)

Public Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type

Public Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColor0 As Long
  bmiColor1 As Long
  bmiColor2 As Long
End Type

Public Type DEVMODE
  dmDeviceName As String * CCDEVICENAME
  dmSpecVersion As Integer
  dmDriverVersion As Integer
  dmSize As Integer
  dmDriverExtra As Integer
  dmFields As Long
  dmOrientation As Integer
  dmPaperSize As Integer
  dmPaperLength As Integer
  dmPaperWidth As Integer
  dmScale As Integer
  dmCopies As Integer
  dmDefaultSource As Integer
  dmPrintQuality As Integer
  dmColor As Integer
  dmDuplex As Integer
  dmYResolution As Integer
  dmTTOption As Integer
  dmCollate As Integer
  dmFormName As String * CCFORMNAME
  dmUnusedPadding As Integer
  dmBitsPerPel As Integer
  dmPelsWidth As Long
  dmPelsHeight As Long
  dmDisplayFlags As Long
  dmDisplayFrequency As Long
End Type

Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public myBMP As BITMAPINFO
Public Function FileExists(sFileName As String) As Boolean
  If sFileName$ = "" Then
    FileExists = False
    Exit Function
  End If
  If Len(Dir$(sFileName$)) Then
    FileExists = True
  Else
    FileExists = False
  End If
End Function
Public Function FilenameExtract(filea As String) As String

  Dim a As String, b As String

  a$ = filea$
  b$ = filea$

  Do
    a$ = Left(a$, Len(a$) - 1)
  Loop Until Right$(a$, 1) = "\"

  b$ = Mid$(b$, Len(a$) + 1)
  a$ = Left$(b$, Len(b$) - 4)

  FilenameExtract$ = a$

End Function
Public Function DirectoryExists(strDir As String) As Boolean

  On Error Resume Next

  If Right$(strDir$, 1) <> "\" Then
    strDir$ = strDir$ & "\"
  End If

  If Dir$(strDir$ & "*.*", vbDirectory) = "" Then
    DirectoryExists = False
  Else
    DirectoryExists = True
  End If

End Function

Public Function IsScale(f As Integer) As Boolean

  Dim Z As Integer

  For Z% = 1 To 10
    If f% = Z% * 256 Then
      IsScale = True
      Exit Function
    End If
  Next Z%

  IsScale = False

End Function

Private Sub Main() 'Program Entry Point.

  Dim X As Long, Y As Long, Z As Long, bytArray(192) As Byte

  OriginalScreenWidth = Screen.Width / 15
  OriginalScreenHeight = Screen.height / 15

  Call settingsload

  frmSMS.mnuReset.Caption = "reset" & vbTab & "bkspc"
  frmSMS.mnuPause.Caption = "pause" & vbTab & "pause/brk"
  frmSMS.mnuFullScreenToggle.Caption = "toggle" & vbTab & "esc"
  frmSMS.mnuLoadROM.Caption = "load rom..." & vbTab & "f1"
  frmSMS.mnuCloseROM.Caption = "close rom" & vbTab & "shift+bkspc"
  frmSMS.mnuStateSave.Caption = "save" & vbTab & "f5"
  frmSMS.mnuStateLoad.Caption = "load" & vbTab & "f6"
  frmSMS.mnuMovieRecord.Caption = "record" & vbTab & "f7"
  frmSMS.mnuMoviePlay.Caption = "play" & vbTab & "f8"
  frmSMS.mnuSaveScreenshot.Caption = "save screenshot" & vbTab & "f9"

  Call vdp.loadPalette(Palette_Colored) 'load palette

  If DirectoryExists(App.Path & "\states") = False Then Call MkDir(App.Path & "\states") 'make states directory
  If DirectoryExists(App.Path & "\movies") = False Then Call MkDir(App.Path & "\movies") 'make movies directory
  If DirectoryExists(App.Path & "\screenshots") = False Then Call MkDir(App.Path & "\screenshots") 'make screenshots directory

  ggcontroller = 255& 'gg controller default
  controller1 = 255& 'controller 1 defaults
  controller2 = 255& 'controller 2 defaults
  StateSlot = 0 'current save slot
  MovieSlot = 0 'current movie slot
  MoviePlaying = False 'no movie playing
  MovieRecording = False 'no movie recording
  LayerDrawBG = True 'draw bg layer
  LayerDrawSprites = True 'draw sprites layer

  frame_two_rom = True

  For X = 0& To 65535 'Calculate Div \ 256.
    glMemAddrDiv256(X) = (X \ 256&)
  Next X

  For X = 0& To 255& 'Calculate Flag Parity.
    Y = True
    For Z = 0& To 7&
      If (X And (2& ^ Z)) <> 0& Then Y = Not Y
    Next Z
    Parity(X) = Y
  Next X

  For X = 1& To 600& 'Calculate Bit Shifts.
    Z = 2
    For Y = 1& To 10&
      ShiftRight(X, Y) = (X \ Z)
      ShiftLeft(X, Y) = (X * Z)
      Z = Z * 2
    Next Y
  Next X
  
  ReDim Mul4000(64) 'Calculate Page Lookup. Upto 1MB.
  For X = 0 To 64
    Mul4000(X) = X * Page1
  Next X

  With myBMP.bmiHeader 'SMS Screen Setup.
    .biWidth = SMS_WIDTH
    .biHeight = -SMS_HEIGHT
    .biSize = 40
    .biBitCount = 32
    .biPlanes = 1
  End With

  Call WindowScale(Zoom_Size)

  Call frmSMS.Show

End Sub
Public Sub ChangeResolution(widthz As Integer, heightz As Integer)

  Dim DevM As DEVMODE

  Call EnumDisplaySettings(0, 0, DevM)

  DevM.dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT
  DevM.dmPelsWidth = widthz
  DevM.dmPelsHeight = heightz

  Call ChangeDisplaySettings(DevM, CDS_FULLSCREEN)

End Sub
Public Sub Switch(f, b)
  Dim c
  c = b
  b = f
  f = c
End Sub
Public Sub WindowScale(f)
  frmSMS.height = 0
  frmSMS.Width = 0
  Do
    frmSMS.Width = frmSMS.Width + 1
  Loop Until frmSMS.ScaleWidth = 256 * f
  Do
    frmSMS.height = frmSMS.height + 1
  Loop Until frmSMS.ScaleHeight = 192 * f
End Sub
Public Sub readCart(url As String) 'Read a cartridge into memory.

  Dim X As Long, Y As Long
  
  Open url For Binary As #1 'Read Cart into Memory.
  Y = LOF(1) 'Store File Length.
  number_of_pages = (Y / &H4000&) 'Calculate Number of Pages.
  ReDim pages(Y) 'Redim Paging Array Accordingly.
  Get #1, , pages() 'Retrieve file data.
  Close #1

  'Default ROM Mapping.
  If (Y >= &HC000&) Then Y = &HC000&
  Call CopyMemory(cartRom(0), pages(0), Y)

End Sub
'------------------------~
'   Output to a Z80 Port.
'------------------------~
Public Sub out(port As Long, value As Long)

    '----------------------------------------~
    '   Not all ports are coded yet, there's
    '   still Sound, and Auto. Nationalisation.
    '----------------------------------------~

    Select Case (port)
        Case &HBE&:     vdp.dataWrite (value)       'VDP Data Port.
        Case &HBF&:     vdp.controlWrite (value)    'VDP Control Port.
        Case &HBD&:     vdp.controlWrite (value)    'VDP Control Port.
        Case 0& To 5&:  vdp.dataWrite (value)       'GG Serial Ports.

        'Case &H7F&
        'Case Else:      Debug.Print "Unknown Port Out " & Hex(port)

    End Select

End Sub

Public Function inn(port As Long) As Long 'Read from a Z80 Port.

  'Not all ports are coded, there's still Controller 2, Horizontal Port..

  If port& = &H0& Then 'game gear controller (for start button).
    If IsGameGear Then
      Call JoystickInput
      If MovieRecording Then Put #3, , ggcontroller
      If MoviePlaying Then Get #3, , ggcontroller: Call MoviePlayEnd
      inn = ggcontroller
      Exit Function
    End If
  End If

  Select Case port&
    Case &H7E& 'Vertical Port.
      inn = vdp.getVCount
    'Case &H7F& 'horizontal port
    Case &HDC& 'controller 1 and some of controller 2.
      Call JoystickInput
      If MovieRecording Then Put #3, , controller1
      If MoviePlaying Then Get #3, , controller1: Call MoviePlayEnd
      inn = controller1
    Case &HDD& 'rest of controller 2.
      Call JoystickInput
      If MovieRecording Then Put #3, , controller2
      If MoviePlaying Then Get #3, , controller2: Call MoviePlayEnd
      inn = controller2
    Case &HBE& 'VDP Data Port.
      inn = vdp.dataRead
    Case &HBF& 'VDP Control Port.
      inn = vdp.controlRead
    Case Else
      inn = 255& 'Default Value.
  End Select

  Exit Function

End Function
