Attribute VB_Name = "shared"
Option Explicit

Public cartRam(8192) As Byte 'Cart RAM.  (8K)
Public cartRom(49152) As Byte 'ROM Pages, 0,1,2 (SaveRAM)
Public frame_two_rom As Long 'Does frame 2 use ROM or SRAM.
Public glMemAddrDiv256(65535) As Long 'Lookup table for speed division.
Public DoGameGearBorder As Boolean 'show the game gear border or not
Public IsGameGear As Boolean 'checks to see if it's a game gear game or not
Public Mul4000() As Long 'Lookup table for * &H4000&
Public number_of_pages As Long 'How many pages exist in a ROM.
Public pages() As Byte 'Holds ROM file data.
Public ROM_Name As String 'holds the rom's name in ram
Public ShiftRight(600, 1 To 10) As Long 'Lookup table for speed ShiftRight.
Public ShiftLeft(600, 1 To 10)  As Long 'Lookup table for speed ShiftLeft.
Public SRAM(16384) As Byte 'Cartridge Ram Page 1 (Save RAM).
Public MemoryEditorOpen As Boolean 'checks if the memory editor is open

Public Const Page1 As Long = &H4000& 'Value For Page 1, (Memory Mapping).
Public Const Page2 As Long = &H8000& 'Value For Page 2, (Memory Mapping).

Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (dest As Any, src As Any, ByVal cb As Long)
Public Function FixValue(a As String) As String 'fixes the addy so it's 2 characters
  If Len(a$) = 1 Then FixValue = "0" & a$: Exit Function
  FixValue = a$
End Function
Public Function FixAddress(a As String) As String 'fixes the addy so it's 4 characters
  If Len(a$) = 1 Then FixAddress = "000" & a$: Exit Function
  If Len(a$) = 2 Then FixAddress = "00" & a$: Exit Function
  If Len(a$) = 3 Then FixAddress = "0" & a$: Exit Function
  FixAddress = a$
End Function
Public Sub CompatibiltyHacks(hash As String)

  'Call InputBox("", "", hash$)

  If hash$ = "BC48365D" Then HACK_Spider = True Else HACK_Spider = False 'spiderman sinister six
  If hash$ = "DF400BEE" Then pages(&H1C12F) = &H0&: pages(&H1C12F + 1) = &H0&: pages(&H1C12F + 2) = &H0& 'hang on/safari hunt bios
  If hash$ = "6A2AA22B" Then pages(&H17EDE) = &H0&: pages(&H17EDE + 1) = &H0&: pages(&H17EDE + 2) = &H0& 'alex kidd in miracle world bios
  If hash$ = "5A9E9435" Then pages(&H26FA) = &H0&: pages(&H26FA + 1) = &H0&: pages(&H26FA + 2) = &H0& 'sonic euro bios
  If hash$ = "C2FF32" Then pages(&HFB5) = &HDD&: pages(&HFB5 + 1) = &H4E&: pages(&HFB5 + 2) = &HFF& '20 em 1
  If hash$ = "8BD837E9" Then pages(&H45D) = &H0&: pages(&H45D + 1) = &H0& 'wanted
  If hash$ = "8E620D1B" Then pages(&H173) = &HC& 'sports pad soccer
  If hash$ = "ED26A448" Then pages(&H5A7) = &HAF&: pages(&H5A7 + 1) = &H0& 'american pro football
  If hash$ = "B343492D" Then pages(&H592) = &HAF&: pages(&H592 + 1) = &H0& 'walter payton
  If hash$ = "A5F1F4DE" Then pages(&H25B) = &H0&: pages(&H25B + 1) = &H0& 'wonder boy 3
  If hash$ = "2894DD55" Then pages(&H25B) = &H0&: pages(&H25B + 1) = &H0& 'monica em o res

End Sub
Public Function FileExists(sFileName As String) As Boolean

  If sFileName$ = "" Then
    FileExists = False
    Exit Function
  End If

  If Len(Dir$(sFileName$)) Then
    FileExists = True
  Else
    FileExists = False
  End If

End Function
Public Function FilenameExtract(filea As String) As String

  Dim a As String, b As String

  a$ = filea$
  b$ = filea$

  Do
    a$ = Left(a$, Len(a$) - 1)
  Loop Until Right$(a$, 1) = "\"

  b$ = Mid$(b$, Len(a$) + 1)
  a$ = Left$(b$, Len(b$) - 4)

  FilenameExtract$ = a$

End Function
Public Function DirectoryExists(strDir As String) As Boolean

  On Error Resume Next

  If Right$(strDir$, 1) <> "\" Then
    strDir$ = strDir$ & "\"
  End If

  If Dir$(strDir$ & "*.*", vbDirectory) = "" Then
    DirectoryExists = False
  Else
    DirectoryExists = True
  End If

End Function

Private Sub Main() 'Program Entry Point.

  Dim x As Long, Y As Long, Z As Long, bytArray(192) As Byte

  Call timeBeginPeriod(1&) 'fixes timing?

  OriginalScreenWidth = Screen.Width / 15
  OriginalScreenHeight = Screen.height / 15

  Call settingsload

  frmSMS.mnuBookmarks.Visible = False
  frmSMS.mnuResults.Visible = False

  frmSMS.mnuReset.Caption = "reset" & vbTab & "bkspc"
  frmSMS.mnuPause.Caption = "pause" & vbTab & "pause/brk"
  frmSMS.mnuFullScreenToggle.Caption = "toggle" & vbTab & "esc"
  frmSMS.mnuLoadROM.Caption = "load rom..." & vbTab & "f1"
  frmSMS.mnuCloseROM.Caption = "close rom" & vbTab & "shift+bkspc"
  frmSMS.mnuStateSave.Caption = "save" & vbTab & "f5"
  frmSMS.mnuStateLoad.Caption = "load" & vbTab & "f6"
  frmSMS.mnuMovieRecord.Caption = "record" & vbTab & "f7"
  frmSMS.mnuMoviePlay.Caption = "play" & vbTab & "f8"
  frmSMS.mnuSaveScreenshot.Caption = "save screenshot" & vbTab & "f9"

  Call vdp.LoadPalette 'load palette

  If DirectoryExists(App.Path & "\states") = False Then Call MkDir(App.Path & "\states") 'make states directory
  If DirectoryExists(App.Path & "\movies") = False Then Call MkDir(App.Path & "\movies") 'make movies directory
  If DirectoryExists(App.Path & "\screenshots") = False Then Call MkDir(App.Path & "\screenshots") 'make screenshots directory
  If DirectoryExists(App.Path & "\bookmarks") = False Then Call MkDir(App.Path & "\bookmarks") 'make bookmarks directory
  If DirectoryExists(App.Path & "\temporary") = False Then Call MkDir(App.Path & "\temporary") 'make temporary directory

  ggcontroller = 255& 'gg controller default
  controller1 = 255& 'controller 1 defaults
  controller2 = 255& 'controller 2 defaults
  StateSlot = 0 'current save slot
  MovieSlot = 0 'current movie slot
  MoviePlaying = False 'no movie playing
  MovieRecording = False 'no movie recording
  LayerDrawBG = True 'draw bg layer
  LayerDrawSprites = True 'draw sprites layer

  frame_two_rom = True

  For x = 0& To 65535 'Calculate Div \ 256.
    glMemAddrDiv256(x) = (x \ 256&)
  Next x

  For x = 0& To 255& 'Calculate Flag Parity.
    Y = True
    For Z = 0& To 7&
      If (x And (2& ^ Z)) <> 0& Then Y = Not Y
    Next Z
    Parity(x) = Y
  Next x

  For x = 1& To 600& 'Calculate Bit Shifts.
    Z = 2
    For Y = 1& To 10&
      ShiftRight(x, Y) = (x \ Z)
      ShiftLeft(x, Y) = (x * Z)
      Z = Z * 2
    Next Y
  Next x
  
  ReDim Mul4000(64) 'Calculate Page Lookup. Upto 1MB.
  For x = 0 To 64
    Mul4000(x) = x * Page1
  Next x

  With myBMP.bmiHeader 'SMS Screen Setup.
    .biWidth = SMS_WIDTH
    .biHeight = -SMS_HEIGHT
    .biSize = 40
    .biBitCount = 32
    .biPlanes = 1
  End With

  Call WindowScale(Zoom_Size)

  Call frmSMS.Show

  If Command$ <> "" Then
    Call LoadROM(Replace(Command$, Chr$(34), ""))
  End If

End Sub
Public Sub WindowScale(f)
  frmSMS.height = 0
  frmSMS.Width = 0
  Do
    frmSMS.Width = frmSMS.Width + 1
  Loop Until frmSMS.ScaleWidth = 256 * f
  Do
    frmSMS.height = frmSMS.height + 1
  Loop Until frmSMS.ScaleHeight = 192 * f
End Sub
Public Sub LoadROM(url As String) 'Read a cartridge into memory.

  Dim x As Long, Y As Long, Z As Long, hash As String

  If FileExists(url$) = False Then Exit Sub 'checks if the file doesn't exist

  If LCase$(Right$(url$, 3)) = "zip" Then 'checks if it's a zip file
    Dim oUnZip As CGUnzipFiles
    Set oUnZip = New CGUnzipFiles
    oUnZip.ZipFileName = url$ 'gets the filename
    oUnZip.ExtractDir = App.Path & "\temporary\" 'sets the extraction directory
    Call oUnZip.Unzip 'unzips it
    If FileExists(App.Path & "\temporary\" & FilenameExtract(url$) & ".gg") = True Then url$ = App.Path & "\temporary\" & FilenameExtract(url$) & ".gg" 'sets if it's gg
    If FileExists(App.Path & "\temporary\" & FilenameExtract(url$) & ".sms") = True Then url$ = App.Path & "\temporary\" & FilenameExtract(url$) & ".sms" 'sets if it's sms
    Set oUnZip = Nothing
  End If

  Open url For Binary As #1 'Read Cart into Memory.
  Y = LOF(1) 'Store File Length.
  Z = Y Mod &H4000& 'check if it has a header (first 512 bytes, if so, skip)
  number_of_pages = (Y / &H4000&) 'Calculate Number of Pages.
  ReDim pages(Y) 'Redim Paging Array Accordingly.
  Get #1, Z + 1, pages() 'Retrieve file data (header aware).
  Close #1

  Call CompatibiltyHacks(getcrc32(pages))

  'Default ROM Mapping.
  If (Y >= &HC000&) Then Y = &HC000&
  Call CopyMemory(cartRom(0), pages(0), Y)

  ROM_Name$ = FilenameExtract$(url$) 'stores rom name for use with save state filenames, etc.

  If LCase$(Right$(url$, 3)) = "sms" Then IsGameGear = False Else IsGameGear = True 'detects whether it's a SMS or GG game
  If MemoryEditorOpen = True Then Call BookmarksLoad 'checks if the memory editor's open and clears/loads bookmarks
  If FullScreenOnROM Then Call frmSMS.mnuFullScreenToggle_Click 'checks whether to switch to full screen or not

  Call frmSMS.mnuReset_Click 'resets the SMS/GG
  Executing = True 'sets executing boolean operator
  Call z80.execute 'starts execution

End Sub
Public Sub out(port As Long, value As Long) 'Output to a Z80 Port. Not all ports are coded yet, there's still Sound, and Auto. Nationalisation.

  Select Case (port)
    'GG Serial Ports.
    Case 0& To 6&
      If IsGameGear Then Call vdp.datawrite(value)
    'VDP Data Port.
    Case &H80&, &H82&, &H84&, &H86&, &H88&, &H8A&, &H8C&, &H8E&, &H90&, &H92&, &H94&, &H96&, &H98&, &H9A&, &H9C&, &H9E&, &HA0&, &HA2&, &HA4&, &HA6&, &HA8&, &HAA&, &HAC&, &HAE&, &HB0&, &HB2&, &HB4&, &HB6&, &HB8&, &HBA&, &HBC&, &HBE&
      Call vdp.datawrite(value)
    'VDP Control Port.
    Case &H81&, &H83&, &H85&, &H87&, &H89&, &H8B&, &H8D&, &H8F&, &H91&, &H93&, &H95&, &H97&, &H99&, &H9B&, &H9D&, &H9F&, &HA1&, &HA3&, &HA5&, &HA7&, &HA9&, &HAB&, &HAD&, &HAF&, &HB1&, &HB3&, &HB5&, &HB7&, &HB9&, &HBB&, &HBD&, &HBF&
      Call vdp.controlwrite(value)
  End Select

End Sub
Public Function inn(port As Long) As Long 'Read from a Z80 Port.

  Select Case port&
    'game gear controller port (for start button)
    Case &H0&
      If IsGameGear Then
        If MovieRecording Then Put #3, , ggcontroller
        If MoviePlaying Then Get #3, , ggcontroller: Call MoviePlayEnd
        inn = ggcontroller
      Else
        inn = 255&
      End If
    'Vertical Port.
    Case &H40&, &H42&, &H44&, &H46&, &H48&, &H4A&, &H4C&, &H4E&, &H50&, &H52&, &H54&, &H56&, &H58&, &H5A&, &H5C&, &H5E&, &H60&, &H62&, &H64&, &H66&, &H68&, &H6A&, &H6C&, &H6E&, &H70&, &H72&, &H74&, &H76&, &H78&, &H7A&, &H7C&, &H7E&
      inn = vdp.getVCount
    'controller 1 and some of controller 2.
    Case &HC0&, &HC2&, &HC4&, &HC6&, &HC8&, &HCA&, &HCC&, &HCE&, &HD0&, &HD2&, &HD4&, &HD6&, &HD8&, &HDA&, &HDC&, &HDE&, &HE0&, &HE2&, &HE4&, &HE6&, &HE8&, &HEA&, &HEC&, &HEE&, &HF0&, &HF2&, &HF4&, &HF6&, &HF8&, &HFA&, &HFC&, &HFE&
      If MovieRecording Then Put #3, , controller1
      If MoviePlaying Then Get #3, , controller1: Call MoviePlayEnd
      inn = controller1
    'rest of controller 2.
    Case &HC1&, &HC3&, &HC5&, &HC7&, &HC9&, &HCB&, &HCD&, &HCF&, &HD1&, &HD3&, &HD5&, &HD7&, &HD9&, &HDB&, &HDD&, &HDF&, &HE1&, &HE3&, &HE5&, &HE7&, &HE9&, &HEB&, &HED&, &HEF&, &HF1&, &HF3&, &HF5&, &HF7&, &HF9&, &HFB&, &HFD&, &HFF&
      If MovieRecording Then Put #3, , controller2
      If MoviePlaying Then Get #3, , controller2: Call MoviePlayEnd
      inn = controller2
    'VDP Data Port.
    Case &H80&, &H82&, &H84&, &H86&, &H88&, &H8A&, &H8C&, &H8E&, &H90&, &H92&, &H94&, &H96&, &H98&, &H9A&, &H9C&, &H9E&, &HA0&, &HA2&, &HA4&, &HA6&, &HA8&, &HAA&, &HAC&, &HAE&, &HB0&, &HB2&, &HB4&, &HB6&, &HB8&, &HBA&, &HBC&, &HBE&
      inn = vdp.dataread
    'VDP Control Port.
    Case &H81&, &H83&, &H85&, &H87&, &H89&, &H8B&, &H8D&, &H8F&, &H91&, &H93&, &H95&, &H97&, &H99&, &H9B&, &H9D&, &H9F&, &HA1&, &HA3&, &HA5&, &HA7&, &HA9&, &HAB&, &HAD&, &HAF&, &HB1&, &HB3&, &HB5&, &HB7&, &HB9&, &HBB&, &HBD&, &HBF&
      inn = vdp.controlread
    Case Else
      inn = 255&
  End Select

End Function
